#!/usr/local/bin/perl -w

use Thread;
use Thread::Queue;

$queue = Thread::Queue->new();

$producer = Thread->new(\&produce, $queue);
$consumer = Thread->new(\&consume, $queue);

$producer->join();
$consumer->join();

##################################################
sub produce {
##################################################
    my ($queue) = @_;

    foreach $i (1..10) {
        $queue->enqueue($i);
        print "Produced $i\n";
        sleep(rand(3));
    }
}

##################################################
sub consume {
##################################################
    my ($queue) = @_;
    my $val;

    do {
        $val = $queue->dequeue();
        print "Consumed $val\n";
    } while($val != 10);
}
